GNU bug report logs - #20402
guix cannot download via an http proxy

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Joshua Randall <jcrandall@HIDDEN>; dated Tue, 21 Apr 2015 23:01:01 UTC; Maintainer for guix is bug-guix@HIDDEN.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 1 Jul 2015 08:19:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jul 01 04:19:31 2015
Received: from localhost ([127.0.0.1]:35161 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZADEw-0004cE-B8
	for submit <at> debbugs.gnu.org; Wed, 01 Jul 2015 04:19:30 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53757)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <ludo@HIDDEN>) id 1ZADEu-0004c0-AT
 for 20402 <at> debbugs.gnu.org; Wed, 01 Jul 2015 04:19:28 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1ZADEm-0000TQ-6Z
 for 20402 <at> debbugs.gnu.org; Wed, 01 Jul 2015 04:19:22 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.6 required=5.0 tests=BAYES_20,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:38820)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1ZADEm-0000TK-3G; Wed, 01 Jul 2015 04:19:20 -0400
Received: from reverse-83.fdn.fr ([80.67.176.83]:35915 helo=pluto)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1ZADEl-0003MT-Du; Wed, 01 Jul 2015 04:19:19 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: =?utf-8?B?Q2xhZXMgV2FsbGluICjpn4vlmInoqqAp?=
 <gnu@HIDDEN>
Subject: Re: HTTP and FTP proxies for guix package / guix-daemon
References: <CAGv_=BodrMu03sbaBVWu0ey+AwKLR9QJ6JzQRW=SX3M7-A5MAw@HIDDEN>
 <CAGv_=Bo7WVgbt7-J7M0SSf37xFM4mHXYGwLS4harcjDzzJqsiA@HIDDEN>
 <CAGv_=BqrQqCqGKMQz=N6DX9qDGyQz57=3eYBDhbVrewGD2kBew@HIDDEN>
 <87381zicgg.fsf@HIDDEN>
 <CAGv_=BriLNSHy2MgPioh_hv4xQJSyVXKniOCVTgOsdUTGpU2eA@HIDDEN>
 <87616uzfd8.fsf@HIDDEN>
 <CAGv_=Bo3rdx1GQ3n7mZrT6io9giiSPU0g8SLDZ_BgNVWJrmuPg@HIDDEN>
 <87d20zbj03.fsf@HIDDEN>
 <CAGv_=BqVzDp6GGVE=J7Ej0pg3=tVEPU2u3DiwCVPgwNaRuyLsA@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 13 Messidor an 223 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x3D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-unknown-linux-gnu
Date: Wed, 01 Jul 2015 10:19:14 +0200
In-Reply-To: <CAGv_=BqVzDp6GGVE=J7Ej0pg3=tVEPU2u3DiwCVPgwNaRuyLsA@HIDDEN>
 ("Claes Wallin \=\?utf-8\?B\?KOmfi+WYieiqoCkiJ3M\=\?\= message of "Wed, 17 Jun
 2015 18:46:17 +0200")
Message-ID: <87pp4cxpbx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.6 (-----)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.6 (-----)

"Claes Wallin (=E9=9F=8B=E5=98=89=E8=AA=A0)" <gnu@HIDDEN=
e> skribis:

>>> But guix-daemon still doesn't seem to be honoring http_proxy.
>>
>> As a first test, could you check whether =E2=80=98guix download=E2=80=99=
 honors it?
>
> It does.
>
>> A second test would be:
>>
>>   1. Define =E2=80=98http_proxy=E2=80=99 in your user shell.
>>   2. From the same shell, run =E2=80=98guix build -S gcc --no-substitute=
s=E2=80=99, say.
>>
>> Does that honor =E2=80=98http_proxy=E2=80=99?
>
> http_proxy is set (and exported) in user shell and in the daemon process.

Oops, my instructions were incorrect: =E2=80=98http_proxy=E2=80=99 needs to=
 be defined
in the daemon process.

To test, I first run the daemon like this:

  sudo sh -c 'export http_proxy=3Dfoobar ; ./pre-inst-env guix-daemon --bui=
ld-users-group=3Dguixbuild'

and then I run:

--8<---------------cut here---------------start------------->8---
$ ./pre-inst-env guix build -S gcc --no-substitutes
accepted connection from pid 14399, user ludo
La jenaj derivoj estos konstruataj:
   /gnu/store/s32s498y88sidfnrppsn33nfmhlacpzx-gcc-5.1.0.tar.xz.drv
   /gnu/store/z1n2c3hgl7w2cnz9d5szyjwwy8lp0dav-gcc-5.1.0.tar.bz2.drv
@ build-started /gnu/store/z1n2c3hgl7w2cnz9d5szyjwwy8lp0dav-gcc-5.1.0.tar.b=
z2.drv - x86_64-linux /var/log/guix/drvs/z1//n2c3hgl7w2cnz9d5szyjwwy8lp0dav=
-gcc-5.1.0.tar.bz2.drv.bz2
starting download of `/gnu/store/6a3d39111w0d5n7rzb5p7aliilw0hx1l-gcc-5.1.0=
.tar.bz2' from `http://ftpmirror.gnu.org/gcc/gcc-5.1.0/gcc-5.1.0.tar.bz2'...
ERROR: In procedure struct_vtable: Wrong type argument in position 1 (expec=
ting struct): #f
starting download of `/gnu/store/6a3d39111w0d5n7rzb5p7aliilw0hx1l-gcc-5.1.0=
.tar.bz2' from `ftp://ftp.cs.tu-berlin.de/pub/gnu/gcc/gcc-5.1.0/gcc-5.1.0.t=
ar.bz2'...
ftp://ftp.cs.tu-berlin.de/.../gcc-5.1.0.tar.bz2	  3.9% of 92728.9 KiB (610.=
 KiB/s)  C-c C-cSIGPOLL
--8<---------------cut here---------------end--------------->8---

Here the error message comes from the fact that $http_proxy is a
malformed URL, showing that it *is* honored.  Since the http URL fails,
the download logic falls back to the next URL, which happens to be an
ftp URL, which is unaffected by =E2=80=98http_proxy=E2=80=99.

So it=E2=80=99s working as expected here.

>> And a third test is for substitutes: Are they also downloaded via the
>> proxy?  Here you need to:
>>
>>   1. Define =E2=80=98http_proxy=E2=80=99 in a root shell.
>>   2. Run =E2=80=98guix-daemon=E2=80=99 from this shell.
>>   3. From a user shell, run =E2=80=98guix build gcc=E2=80=99, say, which=
 should normally
>>      download a substitute from hydra.gnu.org rather than trying to build
>>      things.
>>
>> Does the substitute download honor =E2=80=98http_proxy=E2=80=99?

This test also works as expected here:

--8<---------------cut here---------------start------------->8---
$ ./pre-inst-env guix build -S inkscape
accepted connection from pid 15118, user ludo
La jena derivo estos konstruata:
   /gnu/store/fa6ss1ljwb97ns75332nshskj2bv0dh4-inkscape-0.91.tar.gz.drv
La jenaj derivoj estos el=C5=9Dutataj:
   /gnu/store/acmzy3nkms38g6vrphh07bczf5s5mbjd-gnutls-3.4.1
   /gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nettle-3.1.1
@ substituter-started /gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nettle-3.=
1.1 /home/ludo/src/guix/nix/scripts/substitute
found valid signature for '/gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nett=
le-3.1.1', from 'http://hydra.gnu.org/nar/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-=
nettle-3.1.1'
downloading `/gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nettle-3.1.1' (1.7=
 MiB installed)...

[...]

In guix/scripts/substitute.scm:
 182: 2 [#<procedure 1523210 at guix/scripts/substitute.scm:165:9 ()>]
In guix/build/download.scm:
 212: 1 [open-socket-for-uri #]
In web/client.scm:
  73: 0 [open-socket-for-uri #]

web/client.scm:73:16: In procedure open-socket-for-uri:
web/client.scm:73:16: In procedure struct_vtable: Wrong type argument in po=
sition 1 (expecting struct): #f
@ substituter-failed /gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nettle-3.1=
.1 256 fetching path `/gnu/store/vx82jvj1xbppnphl8nwjdr7cm7f5bk59-nettle-3.=
1.1' failed with exit code 1
guix build: error: build failed: some substitutes for the outputs of deriva=
tion `/gnu/store/2v6lls3f8dj1rkpram4jnl8ckqs77r6m-gnutls-3.4.1.drv' failed =
(usually happens due to networking issues); try `--fallback' to build deriv=
ation from source
--8<---------------cut here---------------end--------------->8---

The backtrace again stems from the bogus $http_proxy that I chose (not
nice, but shows that $http_proxy is honored.)

Please let me know if you have evidence that something works differently
for you.

> No. Whenever the daemon is doing the downloading, http_proxy is
> ignored and I get "Temporary failure in name resolution" because the
> VM doesn't have an internet DNS.

[...]

> `/gnu/store/2zkyyw4bq0wzsxdysncrf9lmwl44w5wh-binutils-2.25.tar.bz2'
> from `http://ftpmirror.gnu.org/binutils/binutils-2.25.tar.bz2'...
> ERROR: In procedure getaddrinfo: Temporary failure in name resolution

That=E2=80=99s another, unrelated issue, probably in your network or on your
machine.

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 17 Jun 2015 16:51:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 17 12:51:12 2015
Received: from localhost ([127.0.0.1]:49875 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z5GYR-0001Zw-Pu
	for submit <at> debbugs.gnu.org; Wed, 17 Jun 2015 12:51:12 -0400
Received: from mail.lysator.liu.se ([130.236.254.3]:46898)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <SRS0+Yg3l=G3=clacke.user.lysator.liu.se=gnu@HIDDEN>)
 id 1Z5GYP-0001Zo-QB
 for 20402 <at> debbugs.gnu.org; Wed, 17 Jun 2015 12:51:10 -0400
Received: from mail.lysator.liu.se (localhost [127.0.0.1])
 by mail.lysator.liu.se (Postfix) with ESMTP id 00B8740090
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 18:51:09 +0200 (CEST)
Received: by mail.lysator.liu.se (Postfix, from userid 1004)
 id DD61340091; Wed, 17 Jun 2015 18:51:08 +0200 (CEST)
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on
 bernadotte.lysator.liu.se
X-Spam-Level: 
X-Spam-Status: No, score=-1.0 required=5.0 tests=ALL_TRUSTED
 autolearn=disabled version=3.3.2
X-Spam-Score: -1.0
Received: from mail-oi0-f47.google.com (mail-oi0-f47.google.com
 [209.85.218.47])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-SHA (256/256 bits))
 (No client certificate requested)
 by mail.lysator.liu.se (Postfix) with ESMTPSA id 0367F40040
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 18:51:08 +0200 (CEST)
Received: by oigx81 with SMTP id x81so38717597oig.1
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 09:51:06 -0700 (PDT)
MIME-Version: 1.0
X-Received: by 10.182.97.2 with SMTP id dw2mr5344231obb.85.1434559866640; Wed,
 17 Jun 2015 09:51:06 -0700 (PDT)
Received: by 10.202.175.135 with HTTP; Wed, 17 Jun 2015 09:51:06 -0700 (PDT)
In-Reply-To: <CAGv_=BqVzDp6GGVE=J7Ej0pg3=tVEPU2u3DiwCVPgwNaRuyLsA@HIDDEN>
References: <CAGv_=BodrMu03sbaBVWu0ey+AwKLR9QJ6JzQRW=SX3M7-A5MAw@HIDDEN>
 <CAGv_=Bo7WVgbt7-J7M0SSf37xFM4mHXYGwLS4harcjDzzJqsiA@HIDDEN>
 <CAGv_=BqrQqCqGKMQz=N6DX9qDGyQz57=3eYBDhbVrewGD2kBew@HIDDEN>
 <87381zicgg.fsf@HIDDEN>
 <CAGv_=BriLNSHy2MgPioh_hv4xQJSyVXKniOCVTgOsdUTGpU2eA@HIDDEN>
 <87616uzfd8.fsf@HIDDEN>
 <CAGv_=Bo3rdx1GQ3n7mZrT6io9giiSPU0g8SLDZ_BgNVWJrmuPg@HIDDEN>
 <87d20zbj03.fsf@HIDDEN>
 <CAGv_=BqVzDp6GGVE=J7Ej0pg3=tVEPU2u3DiwCVPgwNaRuyLsA@HIDDEN>
Date: Wed, 17 Jun 2015 18:51:06 +0200
Message-ID: <CAGv_=BqCEHSVJzUtSMsqeyjHL8o+qr-bGaUr2NWPjfJ=7SG5rQ@HIDDEN>
Subject: Re: HTTP and FTP proxies for guix package / guix-daemon
From: =?UTF-8?B?Q2xhZXMgV2FsbGluICjpn4vlmInoqqAp?=
 <gnu@HIDDEN>
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Virus-Scanned: ClamAV using ClamSMTP
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.9 (--)

On Wed, Jun 17, 2015 at 6:46 PM, Claes Wallin (=E9=9F=8B=E5=98=89=E8=AA=A0)
<gnu@HIDDEN> wrote:

> Why so many different guile drivers? Is that expected?


... derivations. Sorry.




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 17 Jun 2015 16:49:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 17 12:49:37 2015
Received: from localhost ([127.0.0.1]:49773 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z5GWu-0001TV-DK
	for submit <at> debbugs.gnu.org; Wed, 17 Jun 2015 12:49:37 -0400
Received: from mail.lysator.liu.se ([130.236.254.3]:46053)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <SRS0+Yg3l=G3=clacke.user.lysator.liu.se=gnu@HIDDEN>)
 id 1Z5GTp-0001Og-Nx
 for 20402 <at> debbugs.gnu.org; Wed, 17 Jun 2015 12:46:27 -0400
Received: from mail.lysator.liu.se (localhost [127.0.0.1])
 by mail.lysator.liu.se (Postfix) with ESMTP id 8D56B40093
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 18:46:23 +0200 (CEST)
Received: by mail.lysator.liu.se (Postfix, from userid 1004)
 id 74EB840040; Wed, 17 Jun 2015 18:46:23 +0200 (CEST)
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on
 bernadotte.lysator.liu.se
X-Spam-Level: 
X-Spam-Status: No, score=-1.0 required=5.0 tests=ALL_TRUSTED,WEIRD_QUOTING
 autolearn=disabled version=3.3.2
X-Spam-Score: -1.0
Received: from mail-oi0-f47.google.com (mail-oi0-f47.google.com
 [209.85.218.47])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-SHA (256/256 bits))
 (No client certificate requested)
 by mail.lysator.liu.se (Postfix) with ESMTPSA id 6712B40040
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 18:46:19 +0200 (CEST)
Received: by oial131 with SMTP id l131so38508051oia.3
 for <20402 <at> debbugs.gnu.org>; Wed, 17 Jun 2015 09:46:17 -0700 (PDT)
MIME-Version: 1.0
X-Received: by 10.60.34.74 with SMTP id x10mr5362432oei.4.1434559577113; Wed,
 17 Jun 2015 09:46:17 -0700 (PDT)
Received: by 10.202.175.135 with HTTP; Wed, 17 Jun 2015 09:46:17 -0700 (PDT)
In-Reply-To: <87d20zbj03.fsf@HIDDEN>
References: <CAGv_=BodrMu03sbaBVWu0ey+AwKLR9QJ6JzQRW=SX3M7-A5MAw@HIDDEN>
 <CAGv_=Bo7WVgbt7-J7M0SSf37xFM4mHXYGwLS4harcjDzzJqsiA@HIDDEN>
 <CAGv_=BqrQqCqGKMQz=N6DX9qDGyQz57=3eYBDhbVrewGD2kBew@HIDDEN>
 <87381zicgg.fsf@HIDDEN>
 <CAGv_=BriLNSHy2MgPioh_hv4xQJSyVXKniOCVTgOsdUTGpU2eA@HIDDEN>
 <87616uzfd8.fsf@HIDDEN>
 <CAGv_=Bo3rdx1GQ3n7mZrT6io9giiSPU0g8SLDZ_BgNVWJrmuPg@HIDDEN>
 <87d20zbj03.fsf@HIDDEN>
Date: Wed, 17 Jun 2015 18:46:17 +0200
Message-ID: <CAGv_=BqVzDp6GGVE=J7Ej0pg3=tVEPU2u3DiwCVPgwNaRuyLsA@HIDDEN>
Subject: Re: HTTP and FTP proxies for guix package / guix-daemon
From: =?UTF-8?B?Q2xhZXMgV2FsbGluICjpn4vlmInoqqAp?=
 <gnu@HIDDEN>
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Virus-Scanned: ClamAV using ClamSMTP
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.9 (--)

Finally got around to this.

On Sat, Jun 13, 2015 at 7:44 PM, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:
> "Claes Wallin (=E9=9F=8B=E5=98=89=E8=AA=A0)" <gnu@HIDDEN=
.se> skribis:
>
>> I suppose if I have a freshly built guix with "guix package -i guix"
>> or "guix package -u guix" it should be using guile 2.0.11 then?
>> Actually looking at the head of .../bin/guix it's referring to a
>> guile-2.0.11.
>
> Yes, so that should be OK.  And it=E2=80=99s Guix > 0.8.2, right?

# /root/.guix-profile/bin/guix --version
guix (GNU Guix) 0.8.3

# ls -l /root/.guix-profile/bin/guix
lrwxrwxrwx 3 root 999 71 Jan  1  1970 /root/.guix-profile/bin/guix ->
/gnu/store/bja9w08pay8rqfs83f3rzlms9q63kymw-guix-0.8.2.a43b55f/bin/guix


>> But guix-daemon still doesn't seem to be honoring http_proxy.
>
> As a first test, could you check whether =E2=80=98guix download=E2=80=99 =
honors it?

It does.

> A second test would be:
>
>   1. Define =E2=80=98http_proxy=E2=80=99 in your user shell.
>   2. From the same shell, run =E2=80=98guix build -S gcc --no-substitutes=
=E2=80=99, say.
>
> Does that honor =E2=80=98http_proxy=E2=80=99?

http_proxy is set (and exported) in user shell and in the daemon process.

No.

> And a third test is for substitutes: Are they also downloaded via the
> proxy?  Here you need to:
>
>   1. Define =E2=80=98http_proxy=E2=80=99 in a root shell.
>   2. Run =E2=80=98guix-daemon=E2=80=99 from this shell.
>   3. From a user shell, run =E2=80=98guix build gcc=E2=80=99, say, which =
should normally
>      download a substitute from hydra.gnu.org rather than trying to build
>      things.
>
> Does the substitute download honor =E2=80=98http_proxy=E2=80=99?

No. Whenever the daemon is doing the downloading, http_proxy is
ignored and I get "Temporary failure in name resolution" because the
VM doesn't have an internet DNS.

As I said earlier, guix has guile-2.0.11 in the hashbang. But
guix-daemon seems to be making use of guile-bootstrap.

If I provoke it a bit I get this:

# find /gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.0/
-name '*.scm' -exec touch {} +
# guix package -i texinfo
 . . .
;;; note: source file
/gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.0/share/guile=
/2.0/ice-9/eval.scm
;;;       newer than compiled
/gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.0/lib/guile/2=
.0/ccache/ice-9/eval.go
;;; note: auto-compilation is enabled, set GUILE_AUTO_COMPILE=3D0
;;;       or pass the --no-auto-compile argument to disable.
. . .
;;; it seems /gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.=
0/share/guile/2.0/ice-9/receive.scm
;;; is part of the compiler; skipping auto-compilation
;;; WARNING: compilation of
/gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.0/share/guile=
/2.0/ice-9/command-line.scm
failed:
;;; ERROR: failed to create path for auto-compiled file
"/gnu/store/cyppdaliwllm1mzgka3cxwxnddk7j2cl-guile-bootstrap-2.0/share/guil=
e/2.0/ice-9/command-line.scm"
starting download of
`/gnu/store/2zkyyw4bq0wzsxdysncrf9lmwl44w5wh-binutils-2.25.tar.bz2'
from `http://ftpmirror.gnu.org/binutils/binutils-2.25.tar.bz2'...
ERROR: In procedure getaddrinfo: Temporary failure in name resolution

... so it's pretty clear that *something* in there is still
referencing the bootstrap guile. But maybe that's expected? Are the
guile packages built using only the bootstrap and not themselves?

/gnu/store/0aq1kq37b6kr562330xz61rg08l6y5yg-guix-0.8.2.a43b55f.drv

has:
Derive([("out","/gnu/store/bja9w08pay8rqfs83f3rzlms9q63kymw-guix-0.8.2.a43b=
55f","","")]
. . . ("/gnu/store/4lkrvcnh2y923la3ivsbyv2m2nv3xpjy-guile-2.0.9.tar.xz.drv"=
,["out"])
. . . ("/gnu/store/d3x2skfxhvqj21w39f6bckmxni1q3bbp-guile-2.0.11.tar.xz.drv=
",["out"])
. . . ("/gnu/store/hvl3gwa57p7k1qnliyy6ymbmz2509azh-guile-2.0.11.drv",["out=
"])
. . . ("/gnu/store/p4i1inysxx5ra0hvhcrd9liw3a5skcbx-guile-2.0.9.tar.xz.drv"=
,["out"])
. . . ("/gnu/store/wlivhx78f1a05dx0blqy209cb1nqwgf5-guile-2.0.9.tar.xz.drv"=
,["out"])
. . . ["/gnu/store/iylwyjzxcy3hkz1wlgpyk4zmhci97rgk-guix-0.8.2.a43b55f-guil=
e-builder"],"x86_64-linux","/gnu/store/cnqmkmj40jmssnx6fkf9n0n3bqj5x426-gui=
le-2.0.11/bin/guile",["--no-auto-compile","-L","/gnu/store/x2nfxrqhdsvir8l6=
5x19bhnrwd4h41rs-module-import","/gnu/store/iylwyjzxcy3hkz1wlgpyk4zmhci97rg=
k-guix-0.8.2.a43b55f-guile-builder"],[("GUILE_LOAD_COMPILED_PATH","/gnu/sto=
re/07n184fk33b7gqkyrbn6b2ckdfisp09i-module-import-compiled"),("out","/gnu/s=
tore/bja9w08pay8rqfs83f3rzlms9q63kymw-guix-0.8.2.a43b55f")])

Why so many different guile drivers? Is that expected?

> Thanks in advance!

No problem!




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 13 Jun 2015 17:45:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 13 13:45:00 2015
Received: from localhost ([127.0.0.1]:52903 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z3pUI-00059e-VB
	for submit <at> debbugs.gnu.org; Sat, 13 Jun 2015 13:44:59 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56031)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <ludo@HIDDEN>) id 1Z3pUH-00059O-7Q
 for 20402 <at> debbugs.gnu.org; Sat, 13 Jun 2015 13:44:57 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1Z3pU8-0007cJ-0r
 for 20402 <at> debbugs.gnu.org; Sat, 13 Jun 2015 13:44:52 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_20,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:44586)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1Z3pU7-0007cC-UP; Sat, 13 Jun 2015 13:44:47 -0400
Received: from reverse-83.fdn.fr ([80.67.176.83]:55883 helo=pluto)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1Z3pU6-0005E5-V5; Sat, 13 Jun 2015 13:44:47 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: =?utf-8?B?Q2xhZXMgV2FsbGluICjpn4vlmInoqqAp?=
 <gnu@HIDDEN>
Subject: Re: HTTP and FTP proxies for guix package / guix-daemon
References: <CAGv_=BodrMu03sbaBVWu0ey+AwKLR9QJ6JzQRW=SX3M7-A5MAw@HIDDEN>
 <CAGv_=Bo7WVgbt7-J7M0SSf37xFM4mHXYGwLS4harcjDzzJqsiA@HIDDEN>
 <CAGv_=BqrQqCqGKMQz=N6DX9qDGyQz57=3eYBDhbVrewGD2kBew@HIDDEN>
 <87381zicgg.fsf@HIDDEN>
 <CAGv_=BriLNSHy2MgPioh_hv4xQJSyVXKniOCVTgOsdUTGpU2eA@HIDDEN>
 <87616uzfd8.fsf@HIDDEN>
 <CAGv_=Bo3rdx1GQ3n7mZrT6io9giiSPU0g8SLDZ_BgNVWJrmuPg@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 25 Prairial an 223 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x3D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-unknown-linux-gnu
Date: Sat, 13 Jun 2015 19:44:44 +0200
In-Reply-To: <CAGv_=Bo3rdx1GQ3n7mZrT6io9giiSPU0g8SLDZ_BgNVWJrmuPg@HIDDEN>
 ("Claes Wallin \=\?utf-8\?B\?KOmfi+WYieiqoCkiJ3M\=\?\= message of "Sat, 13 Jun
 2015 16:34:21 +0200")
Message-ID: <87d20zbj03.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

(Please always keep the bug email address Cc=E2=80=99d.)

"Claes Wallin (=E9=9F=8B=E5=98=89=E8=AA=A0)" <gnu@HIDDEN=
e> skribis:

> I suppose if I have a freshly built guix with "guix package -i guix"
> or "guix package -u guix" it should be using guile 2.0.11 then?
> Actually looking at the head of .../bin/guix it's referring to a
> guile-2.0.11.

Yes, so that should be OK.  And it=E2=80=99s Guix > 0.8.2, right?

> But guix-daemon still doesn't seem to be honoring http_proxy.

As a first test, could you check whether =E2=80=98guix download=E2=80=99 ho=
nors it?

A second test would be:

  1. Define =E2=80=98http_proxy=E2=80=99 in your user shell.
  2. From the same shell, run =E2=80=98guix build -S gcc --no-substitutes=
=E2=80=99, say.

Does that honor =E2=80=98http_proxy=E2=80=99?

And a third test is for substitutes: Are they also downloaded via the
proxy?  Here you need to:

  1. Define =E2=80=98http_proxy=E2=80=99 in a root shell.
  2. Run =E2=80=98guix-daemon=E2=80=99 from this shell.
  3. From a user shell, run =E2=80=98guix build gcc=E2=80=99, say, which sh=
ould normally
     download a substitute from hydra.gnu.org rather than trying to build
     things.

Does the substitute download honor =E2=80=98http_proxy=E2=80=99?

Thanks in advance!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 10 Jun 2015 02:26:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 09 22:26:49 2015
Received: from localhost ([127.0.0.1]:46552 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z2Vj6-0007eJ-M5
	for submit <at> debbugs.gnu.org; Tue, 09 Jun 2015 22:26:48 -0400
Received: from world.peace.net ([50.252.239.5]:42728)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <mhw@HIDDEN>) id 1Z2Vj4-0007eB-E6
 for 20402 <at> debbugs.gnu.org; Tue, 09 Jun 2015 22:26:47 -0400
Received: from [10.1.10.104] (helo=jojen)
 by world.peace.net with esmtpsa (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.72) (envelope-from <mhw@HIDDEN>)
 id 1Z2Viy-0007ki-B6; Tue, 09 Jun 2015 22:26:40 -0400
From: Mark H Weaver <mhw@HIDDEN>
To: Claes Wallin (=?utf-8?B?6Z+L5ZiJ6Kqg?=) <gnu@HIDDEN>
Subject: Re: bug#20402: guix cannot download via an http proxy
References: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
 <CAGv_=BrefcGVvV160y278n00-N1Pf10dX+uOUygwAm2hwK2NNw@HIDDEN>
Date: Tue, 09 Jun 2015 22:26:38 -0400
In-Reply-To: <CAGv_=BrefcGVvV160y278n00-N1Pf10dX+uOUygwAm2hwK2NNw@HIDDEN>
 ("Claes Wallin \=\?utf-8\?B\?KOmfi+WYieiqoCkiJ3M\=\?\= message of "Tue,
 9 Jun 2015 03:22:38 +0200")
Message-ID: <87vbewz4bl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Claes Wallin (=E9=9F=8B=E5=98=89=E8=AA=A0) <gnu@HIDDEN>=
 writes:

> Would support for $ftp_proxy as well require the implementation of new
> functionality, or would it be a case of just letting the environment
> variable through?

It would require new functionality.  Our FTP client would have to be
enhanced to support proxies.

      Mark




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 9 Jun 2015 01:49:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 08 21:49:25 2015
Received: from localhost ([127.0.0.1]:45576 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Z28fM-00033M-Rn
	for submit <at> debbugs.gnu.org; Mon, 08 Jun 2015 21:49:25 -0400
Received: from mail.lysator.liu.se ([130.236.254.3]:39271)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <SRS0+gt2Y=GT=clacke.user.lysator.liu.se=gnu@HIDDEN>)
 id 1Z28FW-0002Ny-8n
 for 20402 <at> debbugs.gnu.org; Mon, 08 Jun 2015 21:22:43 -0400
Received: from mail.lysator.liu.se (localhost [127.0.0.1])
 by mail.lysator.liu.se (Postfix) with ESMTP id E829540026
 for <20402 <at> debbugs.gnu.org>; Tue,  9 Jun 2015 03:22:40 +0200 (CEST)
Received: by mail.lysator.liu.se (Postfix, from userid 1004)
 id D64644001F; Tue,  9 Jun 2015 03:22:40 +0200 (CEST)
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on
 bernadotte.lysator.liu.se
X-Spam-Level: 
X-Spam-Status: No, score=-1.0 required=5.0 tests=ALL_TRUSTED
 autolearn=disabled version=3.3.2
X-Spam-Score: -1.0
Received: from mail-ob0-f173.google.com (mail-ob0-f173.google.com
 [209.85.214.173])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-SHA (256/256 bits))
 (No client certificate requested)
 by mail.lysator.liu.se (Postfix) with ESMTPSA id 73A514001F
 for <20402 <at> debbugs.gnu.org>; Tue,  9 Jun 2015 03:22:40 +0200 (CEST)
Received: by obbir4 with SMTP id ir4so3127233obb.1
 for <20402 <at> debbugs.gnu.org>; Mon, 08 Jun 2015 18:22:38 -0700 (PDT)
MIME-Version: 1.0
X-Received: by 10.60.50.168 with SMTP id d8mr17059023oeo.41.1433812958847;
 Mon, 08 Jun 2015 18:22:38 -0700 (PDT)
Received: by 10.202.175.135 with HTTP; Mon, 8 Jun 2015 18:22:38 -0700 (PDT)
Date: Tue, 9 Jun 2015 03:22:38 +0200
Message-ID: <CAGv_=BrefcGVvV160y278n00-N1Pf10dX+uOUygwAm2hwK2NNw@HIDDEN>
Subject: Re: guix cannot download via an http proxy
From: =?UTF-8?B?Q2xhZXMgV2FsbGluICjpn4vlmInoqqAp?=
 <gnu@HIDDEN>
To: 20402 <at> debbugs.gnu.org
Content-Type: text/plain; charset=UTF-8
X-Virus-Scanned: ClamAV using ClamSMTP
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 20402
X-Mailman-Approved-At: Mon, 08 Jun 2015 21:49:24 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Would support for $ftp_proxy as well require the implementation of new
functionality, or would it be a case of just letting the environment
variable through?




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 30 Apr 2015 22:12:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 30 18:12:46 2015
Received: from localhost ([127.0.0.1]:57841 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YnwhJ-0006vX-KA
	for submit <at> debbugs.gnu.org; Thu, 30 Apr 2015 18:12:45 -0400
Received: from fencepost.gnu.org ([208.118.235.10]:35025 ident=Debian-exim)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <ludo@HIDDEN>) id 1YnwhI-0006vQ-AN
 for 20402 <at> debbugs.gnu.org; Thu, 30 Apr 2015 18:12:44 -0400
Received: from reverse-83.fdn.fr ([80.67.176.83]:34958 helo=pluto)
 by fencepost.gnu.org with esmtpsa (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1YnwhH-0004zI-Qb; Thu, 30 Apr 2015 18:12:44 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Joshua Randall <jcrandall@HIDDEN>
Subject: Re: bug#20402: updated patch to pass http_proxy and https_proxy env
 vars to derivation builds
References: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
 <CAFBLGSMGXGz5CXDz6xmz7xez=1c7Vi17b=gY5uyOY80n0WfE=g@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 12 =?utf-8?Q?Flor=C3=A9al?= an 223 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x3D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-unknown-linux-gnu
Date: Fri, 01 May 2015 00:12:42 +0200
In-Reply-To: <CAFBLGSMGXGz5CXDz6xmz7xez=1c7Vi17b=gY5uyOY80n0WfE=g@HIDDEN>
 (Joshua Randall's message of "Wed, 22 Apr 2015 15:22:50 +0100")
Message-ID: <87bni5fep1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Joshua Randall <jcrandall@HIDDEN> skribis:

> I've updated my patch to also modify guix/derivations.scm to add a setting
> for nix's impureEnvVars, such that it will pass http_proxy and https_proxy
> variables from the guix daemon to the build processes (which nix will do
> only for fixed-output derivations).

I took a slightly different approach in commit c046815 (and also not
passing =E2=80=9CimpureEnvVars=E2=80=9D by default since that would lead to=
 a full
rebuild.)

With commit 0d88313, $http_proxy is honored, but note that it=E2=80=99s the
$http_proxy value in the daemon=E2=80=99s environment that is used, not in =
the
client=E2=80=99s environment.

> I believe this is working, but I've now run into a third problem: the
> bootstrap guile is only v2.0.9, and v.2.0.10 or later is required for pro=
xy
> support. What would I need to do to use a later version of bootstrap guil=
e?

We will need to update the bootstrap Guile, but that won=E2=80=99t happen u=
ntil
a later full-rebuild cycle.

You should be able to use substitutes as a workaround in the meantime.
How does that sound?

Thank you!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 30 Apr 2015 22:08:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 30 18:08:09 2015
Received: from localhost ([127.0.0.1]:57837 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ynwcq-0006ox-UX
	for submit <at> debbugs.gnu.org; Thu, 30 Apr 2015 18:08:09 -0400
Received: from fencepost.gnu.org ([208.118.235.10]:34955 ident=Debian-exim)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <ludo@HIDDEN>) id 1Ynwcp-0006oq-Ep
 for 20402 <at> debbugs.gnu.org; Thu, 30 Apr 2015 18:08:08 -0400
Received: from reverse-83.fdn.fr ([80.67.176.83]:34952 helo=pluto)
 by fencepost.gnu.org with esmtpsa (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1Ynwco-0004OI-Km; Thu, 30 Apr 2015 18:08:07 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Joshua Randall <jcrandall@HIDDEN>
Subject: Re: bug#20402: guix cannot download via an http proxy
References: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
 <CAFBLGSN8Gu5-=NsFuHumomtG80jNO94Sjc9AsuSZvkT9R46eEg@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 11 =?utf-8?Q?Flor=C3=A9al?= an 223 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x3D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-unknown-linux-gnu
Date: Fri, 01 May 2015 00:07:59 +0200
In-Reply-To: <CAFBLGSN8Gu5-=NsFuHumomtG80jNO94Sjc9AsuSZvkT9R46eEg@HIDDEN>
 (Joshua Randall's message of "Wed, 22 Apr 2015 02:15:58 +0100")
Message-ID: <87r3r1feww.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 20402
Cc: 20402 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Hi,

Sorry for the delay, and thanks for the investigation and patch!

Joshua Randall <jcrandall@HIDDEN> skribis:

> This patch modifies http-fetch (in build/download.scm) such that it calls
> Guile's open-socket-for-uri after fixing up the uri so that it always has=
 a
> port specified. I'm not sure how to test the bootstrapping NSS issue that
> required open-connection-for-uri, but my expectation based on reading the
> source is that this alternative should work for Guile > 2.0.7, and I've
> left the original open-connection-for-uri in there for backwards
> compatibility with Guile < 2.0.7. If someone can test this against a
> situation known to have needed the NSS workaround, that would be great.

To name lookup with the bootstrap Guile, one way is to run this:

  $ guix gc -d $(guix build -S -e '(@@ (gnu packages commencement) glibc-fi=
nal)')
  $ ./pre-inst-env guix build -S \
     -e '(@@ (gnu packages commencement) glibc-final)' --no-substitutes

The second command here uses the bootstrap Guile.

Another approach is this:

--8<---------------cut here---------------start------------->8---
scheme@(guile-user)> ,use(gnu packages bootstrap)
scheme@(guile-user)> ,enter-store-monad
store-monad@(guile-user) [1]> (mlet %store-monad ((guile (package->derivati=
on %bootstrap-guile)))
				(gexp->derivation "foo"
						  #~(begin
						      (mkdir #$output)
						      (pk (getaddrinfo "www.gnu.org" "http")))
						  #:hash-algo 'sha256
						  #:hash (base32 "0mdqa9w1p6cmli6976v4wi0sw9r4p5prkj7lzfd1877wk11c9c7=
3")
						  #:guile-for-build guile))
$5 =3D #<derivation /gnu/store/5prfiblj6ddziavk9nz31bkgy8jzaghx-foo.drv =3D=
> /gnu/store/xf3404zw9kfx6a1gcfk6lmqcx6a53ad5-foo 2ae7960>
store-monad@(guile-user) [1]> (built-derivations (list $5))
building path(s) `/gnu/store/xf3404zw9kfx6a1gcfk6lmqcx6a53ad5-foo'

;;; ((#(0 2 1 6 #(2 3497454484 80) #f) #(0 2 2 17 #(2 3497454484 80) #f) #(=
0 10 1 6 #(10 42541952298791455573290623124440612874 80 0 0) #f) #(0 10 2 1=
7 #(10 42541952298791455573290623124440612874 80 0 0) #f)))
--8<---------------cut here---------------end--------------->8---

Here =E2=80=98built-derivations=E2=80=99 fails but the build log shows that
=E2=80=98getaddrinfo=E2=80=99 succeeded.

Lastly, one can extract
gnu/packages/bootstrap/x86_64-linux/guile-2.0.9.tar.xz and run:

  strace -o log ./bin/guile -c '(getaddrinfo "www.gnu.org" "http")'

Here the log shows that /etc/nsswitch.conf, /etc/services, and
/etc/hosts are accessed and things just work; it does not attempt to
connect to the nscd.

A bit of archeology shows the following timeline:

  1. d14ecda introduces the =E2=80=98open-connection-for-uri=E2=80=99 hack =
(Oct. 2012).

  2. d3b5972 changes libc used to make bootstrap tarballs to use static
     NSS modules (Jan. 2013).

  3. 0621349 updates the bootstrap guile-2.0.9.tar.xz tarballs
     (Nov. 2013), meaning that our current bootstrap Guile indeed uses
     static NSS modules and doesn=E2=80=99t attempt to talk to nscd.

In other words, the hack is no longer needed.

Thus, =E2=80=98open-connection-for-uri=E2=80=99 is almost (see below) unnee=
ded now,
which simplifies the solution to the problem you raise.

> I've also changed the only other call to open-connection-for-uri, which is
> in the probe-uri function in scripts/lint.scm - my suspicion is that won't
> be an issue because I'm guessing the lint scripts are not used while
> bootstrapping, so the open-socket-for-uri function will probably be fine
> for the purpose of probing whether a URL is valid.

=E2=80=98open-connection-for-uri=E2=80=99 also handles TLS connections, whi=
ch are also
useful for =E2=80=98guix lint=E2=80=99, so we cannot completely get rid of =
it.

Commit d17551d simplifies it so that it is just a wrapper around
=E2=80=98open-socket-for-uri=E2=80=99.  After that, =E2=80=98guix download=
=E2=80=99 honors $http_proxy.

$https_proxy is not handled yet because that requires more work, and I
do not fully understand how that is supposed to work.  Patch welcome,
though.  :-)

Thanks!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 22 Apr 2015 14:22:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 22 10:22:59 2015
Received: from localhost ([127.0.0.1]:36622 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YkvYJ-00013C-At
	for submit <at> debbugs.gnu.org; Wed, 22 Apr 2015 10:22:59 -0400
Received: from mail-lb0-f179.google.com ([209.85.217.179]:32913)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jrandall@HIDDEN>) id 1YkvYH-000130-95
 for 20402 <at> debbugs.gnu.org; Wed, 22 Apr 2015 10:22:58 -0400
Received: by lbbzk7 with SMTP id zk7so181476827lbb.0
 for <20402 <at> debbugs.gnu.org>; Wed, 22 Apr 2015 07:22:51 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:date:message-id:subject:from:to:content-type;
 bh=51Kpm5dN+2GA6Qmt5wHjq2X0+TqxCbkqWm0qwacD0Q8=;
 b=LUvZTqkNhy5xh79XxiyJd0LkQxAAs6HztXNrz81d6cdn3CsovpdHA5VeY4lVbGaUnF
 /8sOyZ1vu4oAjDxmx6Ctzki0ZIdbptRf5lJm59sttYnAYdqvJofeBxVC/BNyFarpowFI
 v4g7612oNhY53CZ4yGEoDpDjutCyE6a+t2qsrsClir3Qbk5CIh8CUtfZrOwO5I8Zv3M/
 a4L99n+JYL+/OLYp18dE5mlEl3ABxwI/yrgIJbhDsy30amLMTiONbBXLBJJLuzz0hkb/
 xV77v4UkMeb8p8PNIdNfLVUZnK52welbsN7KBT/X4HgZ8UY387QtkRmwy+oUkaBijbwy
 6J3w==
MIME-Version: 1.0
X-Received: by 10.152.7.209 with SMTP id l17mr25185906laa.100.1429712571417;
 Wed, 22 Apr 2015 07:22:51 -0700 (PDT)
Received: by 10.25.80.9 with HTTP; Wed, 22 Apr 2015 07:22:50 -0700 (PDT)
Date: Wed, 22 Apr 2015 15:22:50 +0100
X-Google-Sender-Auth: DZoHOkDCnB9z9NqJm3p2eKfTT80
Message-ID: <CAFBLGSMGXGz5CXDz6xmz7xez=1c7Vi17b=gY5uyOY80n0WfE=g@HIDDEN>
Subject: updated patch to pass http_proxy and https_proxy env vars to
 derivation builds
From: Joshua Randall <jcrandall@HIDDEN>
To: 20402 <at> debbugs.gnu.org
Content-Type: multipart/mixed; boundary=001a11c33c0af37a17051450e58d
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 20402
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c33c0af37a17051450e58d
Content-Type: multipart/alternative; boundary=001a11c33c0af37a12051450e58b

--001a11c33c0af37a12051450e58b
Content-Type: text/plain; charset=UTF-8

Tags: patch

I've updated my patch to also modify guix/derivations.scm to add a setting
for nix's impureEnvVars, such that it will pass http_proxy and https_proxy
variables from the guix daemon to the build processes (which nix will do
only for fixed-output derivations).

I believe this is working, but I've now run into a third problem: the
bootstrap guile is only v2.0.9, and v.2.0.10 or later is required for proxy
support. What would I need to do to use a later version of bootstrap guile?

Cheers,

Josh.

--001a11c33c0af37a12051450e58b
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Tags: patch<div><br></div><div>I&#39;ve updated my patch t=
o also modify guix/derivations.scm to add a setting for nix&#39;s impureEnv=
Vars, such that it will pass http_proxy and https_proxy variables from the =
guix daemon to the build processes (which nix will do only for fixed-output=
 derivations).=C2=A0<div><br></div><div>I believe this is working, but I&#3=
9;ve now run into a third problem: the bootstrap guile is only v2.0.9, and =
v.2.0.10 or later is required for proxy support. What would I need to do to=
 use a later version of bootstrap guile?=C2=A0</div></div><div><br></div><d=
iv>Cheers,</div><div><br></div><div>Josh.</div><div><br></div></div>

--001a11c33c0af37a12051450e58b--
--001a11c33c0af37a17051450e58d
Content-Type: application/octet-stream; 
	name="guix-git-dd3a42e6-http-proxy-impure-fix.patch"
Content-Disposition: attachment; 
	filename="guix-git-dd3a42e6-http-proxy-impure-fix.patch"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i8sty2bw0
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--001a11c33c0af37a17051450e58d--




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 22 Apr 2015 09:08:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 22 05:08:36 2015
Received: from localhost ([127.0.0.1]:35745 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ykqe4-0000Wl-Ad
	for submit <at> debbugs.gnu.org; Wed, 22 Apr 2015 05:08:36 -0400
Received: from mail-lb0-f177.google.com ([209.85.217.177]:36438)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jrandall@HIDDEN>) id 1Ykqe1-0000WO-9V
 for 20402 <at> debbugs.gnu.org; Wed, 22 Apr 2015 05:08:34 -0400
Received: by lbbqq2 with SMTP id qq2so174858982lbb.3
 for <20402 <at> debbugs.gnu.org>; Wed, 22 Apr 2015 02:08:27 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:in-reply-to:references:date:message-id:subject
 :from:to:content-type;
 bh=Gyf3kDnqWZfMOip4q0SqkgcOYeDbVphkAIS2iDA0C50=;
 b=qBfiXMXwgAeilO5zUNSOdlJpUqP0pdcMv5cj7xq1pA1w9rvOlCDoVtIJ/WKPTMdDth
 QpFPjfg5H522XoM2TmnUB6TRg9e0wUWsgJtx2O//HD9driFhB+4nfp27RJQUkkJlmi97
 LTCk1Cxr1Jtcx+uWVAE5JufjmaAblddY8dMehTM7ABfyHvyXJKS+osPS/YNwfpEO6hoc
 4ZXDgKcvylJZUn27GPEetaBhVzX0iqnuN3XJoPei4vk9X+U5sSKqz/UQzsscHlx3NLkv
 DBfJFiqVwp+S3U22vXlu/uY8Znu4PWrENFjirI3dj7SKt7vOsEnDTKNoYMxqmyfS9/wa
 GlWQ==
MIME-Version: 1.0
X-Received: by 10.112.204.6 with SMTP id ku6mr23515469lbc.73.1429693707251;
 Wed, 22 Apr 2015 02:08:27 -0700 (PDT)
Received: by 10.25.80.9 with HTTP; Wed, 22 Apr 2015 02:08:27 -0700 (PDT)
In-Reply-To: <CAFBLGSN8Gu5-=NsFuHumomtG80jNO94Sjc9AsuSZvkT9R46eEg@HIDDEN>
References: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
 <CAFBLGSN8Gu5-=NsFuHumomtG80jNO94Sjc9AsuSZvkT9R46eEg@HIDDEN>
Date: Wed, 22 Apr 2015 10:08:27 +0100
X-Google-Sender-Auth: 926QvTDAG_MiLobPrtm48j2WrWg
Message-ID: <CAFBLGSOaeXcbZpWAUByAkfe+kanD_2O+x97WW6A02yNPApVKTQ@HIDDEN>
Subject: Re: guix cannot download via an http proxy
From: Joshua Randall <jcrandall@HIDDEN>
To: 20402 <at> debbugs.gnu.org
Content-Type: multipart/alternative; boundary=001a11c3db828ef7f105144c816d
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 20402
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3db828ef7f105144c816d
Content-Type: text/plain; charset=UTF-8

After more testing this morning, I see that although the core functionality
is working after applying the proposed patch (i.e. the guix daemon itself
can download things), the derivations are still failing because the
environment is being squashed and so the http_proxy and https_proxy
environment variables are not available to the build. It looks like nix has
a way around this involving setting imputeEnvVars = "http_proxy
https_proxy" so that those variables get copied into the build environment
(for fixed-output derivations only, which makes sense to me).

I'll try to come up with a patch that inserts the imputeEnvVars, but I'm
getting farther from the code I understand so I will probably need some
help in getting it in the right place.

Cheers,

Josh.


On Wed, Apr 22, 2015 at 2:15 AM, Joshua Randall <jcrandall@HIDDEN>
wrote:

> Tags: patch
>
> Please find a proposed patch that should fix this issue. I haven't written
> scheme in many years, so please excuse me if I have failed to follow
> convention in any way - I won't be offended at all if you want to refactor
> it. This patch should apply cleanly on the current git master branch and
> also on the v0.8.1 release.
>
> This patch modifies http-fetch (in build/download.scm) such that it calls
> Guile's open-socket-for-uri after fixing up the uri so that it always has a
> port specified. I'm not sure how to test the bootstrapping NSS issue that
> required open-connection-for-uri, but my expectation based on reading the
> source is that this alternative should work for Guile > 2.0.7, and I've
> left the original open-connection-for-uri in there for backwards
> compatibility with Guile < 2.0.7. If someone can test this against a
> situation known to have needed the NSS workaround, that would be great.
>
> I've also changed the only other call to open-connection-for-uri, which is
> in the probe-uri function in scripts/lint.scm - my suspicion is that won't
> be an issue because I'm guessing the lint scripts are not used while
> bootstrapping, so the open-socket-for-uri function will probably be fine
> for the purpose of probing whether a URL is valid.
>
> After applying this patch, guix should use the http proxy support built in
> to Guile >= 2.0.10. This appears to be working for me - I've just started a
> bootstrap and it has now started to successfully download packages - so
> far, so good.
>
> Please let me know if there is anything else I can do to assist with
> getting this issue fixed.
>
> Cheers,
>
> Josh.
>
>

--001a11c3db828ef7f105144c816d
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">After more testing this morning, I see that although the c=
ore functionality is working after applying the proposed patch (i.e. the gu=
ix daemon itself can download things), the derivations are still failing be=
cause the environment is being squashed and so the http_proxy and https_pro=
xy environment variables are not available to the build. It looks like nix =
has a way around this involving setting imputeEnvVars =3D &quot;http_proxy =
https_proxy&quot; so that those variables get copied into the build environ=
ment (for fixed-output derivations only, which makes sense to me).=C2=A0<di=
v><br></div><div>I&#39;ll try to come up with a patch that inserts the impu=
teEnvVars, but I&#39;m getting farther from the code I understand so I will=
 probably need some help in getting it in the right place.=C2=A0</div><div>=
<br></div><div>Cheers,</div><div><br></div><div>Josh.</div><div><br></div><=
/div><div class=3D"gmail_extra"><br><div class=3D"gmail_quote">On Wed, Apr =
22, 2015 at 2:15 AM, Joshua Randall <span dir=3D"ltr">&lt;<a href=3D"mailto=
:jcrandall@HIDDEN" target=3D"_blank">jcrandall@HIDDEN</a>&gt;</=
span> wrote:<br><blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8e=
x;border-left:1px #ccc solid;padding-left:1ex"><div dir=3D"ltr">Tags: patch=
<div><br></div><div>Please find a proposed patch that should fix this issue=
. I haven&#39;t written scheme in many years, so please excuse me if I have=
 failed to follow convention in any way - I won&#39;t be offended at all if=
 you want to refactor it. This patch should apply cleanly on the current gi=
t master branch and also on the v0.8.1 release.=C2=A0<div><br></div><div>Th=
is patch modifies http-fetch (in build/download.scm) such that it calls Gui=
le&#39;s open-socket-for-uri after fixing up the uri so that it always has =
a port specified. I&#39;m not sure how to test the bootstrapping NSS issue =
that required open-connection-for-uri, but my expectation based on reading =
the source is that this alternative should work for Guile &gt; 2.0.7, and I=
&#39;ve left the original open-connection-for-uri in there for backwards co=
mpatibility with Guile &lt; 2.0.7. If someone can test this against a situa=
tion known to have needed the NSS workaround, that would be great.=C2=A0</d=
iv><div><br></div><div>I&#39;ve also changed the only other call to open-co=
nnection-for-uri, which is in the probe-uri function in scripts/lint.scm - =
my suspicion is that won&#39;t be an issue because I&#39;m guessing the lin=
t scripts are not used while bootstrapping, so the open-socket-for-uri func=
tion will probably be fine for the purpose of probing whether a URL is vali=
d.=C2=A0</div><div><br></div><div>After applying this patch, guix should us=
e the http proxy support built in to Guile &gt;=3D 2.0.10. This appears to =
be working for me - I&#39;ve just started a bootstrap and it has now starte=
d to successfully download packages - so far, so good.=C2=A0</div><div><br>=
</div><div>Please let me know if there is anything else I can do to assist =
with getting this issue fixed.=C2=A0</div><div><br></div><div>Cheers,</div>=
<div><br></div><div>Josh.</div><div><br></div></div></div>
</blockquote></div><br></div>

--001a11c3db828ef7f105144c816d--




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at 20402 <at> debbugs.gnu.org:


Received: (at 20402) by debbugs.gnu.org; 22 Apr 2015 01:16:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 21 21:16:08 2015
Received: from localhost ([127.0.0.1]:35655 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1YkjGp-0000xj-Rt
	for submit <at> debbugs.gnu.org; Tue, 21 Apr 2015 21:16:08 -0400
Received: from mail-la0-f45.google.com ([209.85.215.45]:36521)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jrandall@HIDDEN>) id 1YkjGm-0000x2-Sp
 for 20402 <at> debbugs.gnu.org; Tue, 21 Apr 2015 21:16:05 -0400
Received: by lagv1 with SMTP id v1so163789599lag.3
 for <20402 <at> debbugs.gnu.org>; Tue, 21 Apr 2015 18:15:59 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:in-reply-to:references:date:message-id:subject
 :from:to:content-type;
 bh=DxP+qYvszLTScFedBqmSdKrK8ajCT/a0TKDzwx5sw+Y=;
 b=ed9WOuH6pFKLFHABiA0YeHeioOc24JiBH2IJySbwqEzbZ9vdqdgnj3dcAPybf7bbtJ
 A7WOhWn+NHOesGrI+uNODIRRvNvxNjtlEWM74DlrnUhGIzBk4qzpXE+J25YMS65JuDEO
 iTuPIDcJD75hdsEgHkv5AbN9zi/CZjH9Hk6GBJLc/oGc2XIrPxr5mPy32KVGBRbajCwZ
 OQAr7GMRaWjjEzg++N/sQg7W7P2YygCbThM9lWsjneqgrPNftIzOxelqujuEGkQ5leqT
 NCrysLymZbv7pUirBYwBru5iIkooPV4MR0ibBKeuD4ROu4XneX9Uf5Fv+2CJygZBuHqE
 pDBQ==
MIME-Version: 1.0
X-Received: by 10.112.181.68 with SMTP id du4mr21764078lbc.11.1429665358963;
 Tue, 21 Apr 2015 18:15:58 -0700 (PDT)
Received: by 10.25.80.9 with HTTP; Tue, 21 Apr 2015 18:15:58 -0700 (PDT)
In-Reply-To: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
References: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
Date: Wed, 22 Apr 2015 02:15:58 +0100
X-Google-Sender-Auth: IKRuDDUB-2VsFc_e4EWmJIvkchA
Message-ID: <CAFBLGSN8Gu5-=NsFuHumomtG80jNO94Sjc9AsuSZvkT9R46eEg@HIDDEN>
Subject: Re: guix cannot download via an http proxy
From: Joshua Randall <jcrandall@HIDDEN>
To: 20402 <at> debbugs.gnu.org
Content-Type: multipart/mixed; boundary=001a11c36882ded708051445e7cc
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 20402
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c36882ded708051445e7cc
Content-Type: multipart/alternative; boundary=001a11c36882ded702051445e7ca

--001a11c36882ded702051445e7ca
Content-Type: text/plain; charset=UTF-8

Tags: patch

Please find a proposed patch that should fix this issue. I haven't written
scheme in many years, so please excuse me if I have failed to follow
convention in any way - I won't be offended at all if you want to refactor
it. This patch should apply cleanly on the current git master branch and
also on the v0.8.1 release.

This patch modifies http-fetch (in build/download.scm) such that it calls
Guile's open-socket-for-uri after fixing up the uri so that it always has a
port specified. I'm not sure how to test the bootstrapping NSS issue that
required open-connection-for-uri, but my expectation based on reading the
source is that this alternative should work for Guile > 2.0.7, and I've
left the original open-connection-for-uri in there for backwards
compatibility with Guile < 2.0.7. If someone can test this against a
situation known to have needed the NSS workaround, that would be great.

I've also changed the only other call to open-connection-for-uri, which is
in the probe-uri function in scripts/lint.scm - my suspicion is that won't
be an issue because I'm guessing the lint scripts are not used while
bootstrapping, so the open-socket-for-uri function will probably be fine
for the purpose of probing whether a URL is valid.

After applying this patch, guix should use the http proxy support built in
to Guile >= 2.0.10. This appears to be working for me - I've just started a
bootstrap and it has now started to successfully download packages - so
far, so good.

Please let me know if there is anything else I can do to assist with
getting this issue fixed.

Cheers,

Josh.

--001a11c36882ded702051445e7ca
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Tags: patch<div><br></div><div>Please find a proposed patc=
h that should fix this issue. I haven&#39;t written scheme in many years, s=
o please excuse me if I have failed to follow convention in any way - I won=
&#39;t be offended at all if you want to refactor it. This patch should app=
ly cleanly on the current git master branch and also on the v0.8.1 release.=
=C2=A0<div><br></div><div>This patch modifies http-fetch (in build/download=
.scm) such that it calls Guile&#39;s open-socket-for-uri after fixing up th=
e uri so that it always has a port specified. I&#39;m not sure how to test =
the bootstrapping NSS issue that required open-connection-for-uri, but my e=
xpectation based on reading the source is that this alternative should work=
 for Guile &gt; 2.0.7, and I&#39;ve left the original open-connection-for-u=
ri in there for backwards compatibility with Guile &lt; 2.0.7. If someone c=
an test this against a situation known to have needed the NSS workaround, t=
hat would be great.=C2=A0</div><div><br></div><div>I&#39;ve also changed th=
e only other call to open-connection-for-uri, which is in the probe-uri fun=
ction in scripts/lint.scm - my suspicion is that won&#39;t be an issue beca=
use I&#39;m guessing the lint scripts are not used while bootstrapping, so =
the open-socket-for-uri function will probably be fine for the purpose of p=
robing whether a URL is valid.=C2=A0</div><div><br></div><div>After applyin=
g this patch, guix should use the http proxy support built in to Guile &gt;=
=3D 2.0.10. This appears to be working for me - I&#39;ve just started a boo=
tstrap and it has now started to successfully download packages - so far, s=
o good.=C2=A0</div><div><br></div><div>Please let me know if there is anyth=
ing else I can do to assist with getting this issue fixed.=C2=A0</div><div>=
<br></div><div>Cheers,</div><div><br></div><div>Josh.</div><div><br></div><=
/div></div>

--001a11c36882ded702051445e7ca--
--001a11c36882ded708051445e7cc
Content-Type: application/octet-stream; 
	name="guix-git-dd3a42e6-http-proxy-fix.patch"
Content-Disposition: attachment; 
	filename="guix-git-dd3a42e6-http-proxy-fix.patch"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i8s195200
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--001a11c36882ded708051445e7cc--




Information forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 Apr 2015 23:00:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 21 19:00:12 2015
Received: from localhost ([127.0.0.1]:35606 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ykh9C-0005a7-5N
	for submit <at> debbugs.gnu.org; Tue, 21 Apr 2015 19:00:11 -0400
Received: from mail-la0-f50.google.com ([209.85.215.50]:33843)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jrandall@HIDDEN>) id 1Ykh5M-0005U5-ML
 for submit <at> debbugs.gnu.org; Tue, 21 Apr 2015 18:56:09 -0400
Received: by laat2 with SMTP id t2so162162946laa.1
 for <submit <at> debbugs.gnu.org>; Tue, 21 Apr 2015 15:56:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:date:message-id:subject:from:to:content-type;
 bh=k4dzW7sJf6NbWt+elzOO44yFbYcmLOI2G9hHKdLifMg=;
 b=HdZC2vuCqeB+CUgaEC4wwWmJiNYy8s0JqzUq2WpReUg1nf2/pnsTbqQW0bN4QjUiic
 mk56kDO2y+y6LmHWCv2LFtZ2aDUdDeSLhedkrSvLmm/2asWH03OvFl+atdCvT4qTEqKd
 MDk8BiuZWdhgYphEo279rjZBuBRxr3xAaAh7xKLSlZBolmnirSZB+VGl8tL/EPrXIZMB
 Q0F/CpyhSEOi0SU5EFilrlr8boT0ipol29L/cti0IvizzGW5kflI/wC84oWz+yGC8kl6
 ml3og1k4Ckli2Cm3s0gCfm8ZNM9XqN2BQLtc2FKvasS0Yhm040D1WuJ+c1LnPJtXuNDp
 RiuQ==
MIME-Version: 1.0
X-Received: by 10.152.239.135 with SMTP id vs7mr22182991lac.104.1429656962172; 
 Tue, 21 Apr 2015 15:56:02 -0700 (PDT)
Received: by 10.25.80.9 with HTTP; Tue, 21 Apr 2015 15:56:02 -0700 (PDT)
Date: Tue, 21 Apr 2015 23:56:02 +0100
X-Google-Sender-Auth: 2_PZ6HObWICxUbal8Z8XFEuuuto
Message-ID: <CAFBLGSNKzhWGjCiheo8W5sc=tzmcjw6PkczxsDizVw-nKwnSzQ@HIDDEN>
Subject: guix cannot download via an http proxy
From: Joshua Randall <jcrandall@HIDDEN>
To: submit <at> debbugs.gnu.org
Content-Type: multipart/alternative; boundary=001a1134788c618db6051443f3be
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Tue, 21 Apr 2015 19:00:04 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a1134788c618db6051443f3be
Content-Type: text/plain; charset=UTF-8

Package: guix
Version: 0.8.1

I am attempting to use guix from within a network that does not allow
outbound http connections except via an http proxy. I am using Guile
v2.0.11, which supports http proxies, so my expectation would be that since
I have http_proxy and https_proxy environment variables set, guix would use
the specified proxy for outbound http connections, but instead it appears
to ignore the proxy settings and attempts to contact the http server
directly, which results in a timeout.

For example, when doing a `guix pull` I got the following:
$ guix pull
starting download of `/tmp/guix-file.l1zwZ7' from `
http://git.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz'...
ERROR: In procedure connect: Connection timed out
failed to download "/tmp/guix-file.l1zwZ7" from "
http://git.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz"
guix pull: error: failed to download up-to-date source, exiting

It appears that Guile has had support for http proxies in the web client
package since v2.0.10, and although guix is using the http-get method from
Guile, it isn't using the open-socket-for-uri method, which is the one that
implements making a proxy connection. Instead, guix seems to have copied
and modified the code from an older version of open-socket-for-uri
into open-connection-for-uri
(
http://git.savannah.gnu.org/cgit/guix.git/tree/guix/build/download.scm?id=v0.8.1#n153)
and uses that instead. I suspect what has happened is that the Guile
version of open-socket-for-uri has added proxy support since the code was
copied into open-connection-for-uri. One fix would be to port over the
changes to open-socket-for-uri that were made in Guile 2.0.10.

However, it appears from the code comment that that the reason
open-connection-for-uri copies the functionality of open-socket-for-uri is
to avoid NSS lookups for symbolic port arguments, and it looks to me that
since version 2.0.7 of Guile, its open-socket-for-uri can be convinced not
to do NSS lookups as long as (uri-port uri) is not #f (see
http://git.savannah.gnu.org/cgit/guile.git/tree/module/web/client.scm?id=v2.0.7#n53
).

Rather than porting the new code from Guile's open-socket-for-uri, it might
make more sense to just call open-socket-for-uri with a uri that always has
a port (i.e. implement the same hard-coding for http and https in the
http-fetch function to make sure that uri has the default port set - I
notice for some reason Guile's string->uri parser does not set the port for
http and https even though it has the default ports for both set in the
code. I suppose one could use the existing post-2.0.7? test to keep calling
open-connection-for-uri for backwards compatibility with old versions of
Guile (which in any case don't have proxy support, so for my use case it
doesn't matter).

I can try to put together a patch that implements this fix, although I
haven't written scheme in quite a while, so someone else may be better
suited for it.

Cheers,

Josh.

--001a1134788c618db6051443f3be
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Package: guix<div>Version: 0.8.1</div><div><br></div><div>=
I am attempting to use guix from within a network that does not allow outbo=
und http connections except via an http proxy. I am using Guile v2.0.11, wh=
ich supports http proxies, so my expectation would be that since I have htt=
p_proxy and https_proxy environment variables set, guix would use the speci=
fied proxy for outbound http connections, but instead it appears to ignore =
the proxy settings and attempts to contact the http server directly, which =
results in a timeout.</div><div><br></div><div>For example, when doing a `g=
uix pull` I got the following:=C2=A0</div><div><div>$ guix pull</div><div>s=
tarting download of `/tmp/guix-file.l1zwZ7&#39; from `<a href=3D"http://git=
.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz&#39;.">http://g=
it.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz&#39;.</a>..</=
div><div>ERROR: In procedure connect: Connection timed out</div><div>failed=
 to download &quot;/tmp/guix-file.l1zwZ7&quot; from &quot;<a href=3D"http:/=
/git.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz">http://git=
.savannah.gnu.org/cgit/guix.git/snapshot/guix-master.tar.gz</a>&quot;</div>=
<div>guix pull: error: failed to download up-to-date source, exiting</div><=
/div><div><br></div><div>It appears that Guile has had support for http pro=
xies in the web client package since v2.0.10, and although guix is using th=
e http-get method from Guile, it isn&#39;t using the open-socket-for-uri me=
thod, which is the one that implements making a proxy connection. Instead, =
guix seems to have copied and modified the code from an older version of op=
en-socket-for-uri into <span style=3D"color:rgb(0,0,0)">open-connection-for=
-uri (</span><font color=3D"#000000"><a href=3D"http://git.savannah.gnu.org=
/cgit/guix.git/tree/guix/build/download.scm?id=3Dv0.8.1#n153">http://git.sa=
vannah.gnu.org/cgit/guix.git/tree/guix/build/download.scm?id=3Dv0.8.1#n153<=
/a>) and uses that instead. I suspect what has happened is that the Guile v=
ersion of open-socket-for-uri has added proxy support since the code was co=
pied into open-connection-for-uri. One fix would be to port over the change=
s to open-socket-for-uri that were made in Guile 2.0.10.=C2=A0</font></div>=
<div><font color=3D"#000000"><br></font></div><div><font color=3D"#000000">=
However, it appears from the code comment that that the reason</font><span =
style=3D"color:rgb(0,0,0)">=C2=A0</span><span style=3D"color:rgb(0,0,0)">op=
en-connection-for-uri</span><span style=3D"color:rgb(0,0,0)">=C2=A0copies t=
he functionality of open-socket-for-uri is to avoid NSS lookups for symboli=
c port arguments, and it looks to me that since version 2.0.7 of Guile, its=
 open-socket-for-uri can be convinced not to do NSS lookups as long as (uri=
-port uri) is not #f (see=C2=A0</span><font color=3D"#000000"><a href=3D"ht=
tp://git.savannah.gnu.org/cgit/guile.git/tree/module/web/client.scm?id=3Dv2=
.0.7#n53">http://git.savannah.gnu.org/cgit/guile.git/tree/module/web/client=
.scm?id=3Dv2.0.7#n53</a>).=C2=A0</font></div><div><span style=3D"color:rgb(=
0,0,0)"><br></span></div><div><span style=3D"color:rgb(0,0,0)">Rather than =
porting the new code from Guile&#39;s open-socket-for-uri, it might make mo=
re sense to just call open-socket-for-uri with a uri that always has a port=
 (i.e. implement the same hard-coding for http and https in the http-fetch =
function to make sure that uri has the default port set - I notice for some=
 reason Guile&#39;s string-&gt;uri parser does not set the port for http an=
d https even though it has the default ports for both set in the code. I su=
ppose one could use the existing=C2=A0</span><span style=3D"color:rgb(0,0,0=
)">post-2.0.7? test to keep calling open-connection-for-uri for backwards c=
ompatibility with old versions of Guile (which in any case don&#39;t have p=
roxy support, so for my use case it doesn&#39;t matter).</span></div><div><=
span style=3D"color:rgb(0,0,0)"><br></span></div><div><span style=3D"color:=
rgb(0,0,0)">I can try to put together a patch that implements this fix, alt=
hough I haven&#39;t written scheme in quite a while, so someone else may be=
 better suited for it.=C2=A0</span></div><div><span style=3D"color:rgb(0,0,=
0)"><br></span></div><div><span style=3D"color:rgb(0,0,0)">Cheers,</span></=
div><div><span style=3D"color:rgb(0,0,0)"><br></span></div><div><span style=
=3D"color:rgb(0,0,0)">Josh.</span></div><div><span style=3D"color:rgb(0,0,0=
)"><br></span></div></div>

--001a1134788c618db6051443f3be--




Acknowledgement sent to Joshua Randall <jcrandall@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#20402; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 1 Jul 2015 08:30:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.